#ifndef FT_MINISHELL
# define FT_MINISHELL
# include "libftx/libftx.h"
# include "utils/utils.h"
# include <sys/types.h>
# include <sys/stat.h>
# include <fcntl.h>
#include <stdio.h>
#include <readline/readline.h>
#include <readline/history.h>

int			ft_syntatic_verif(const char *str);
int			ft_file_is_readable(const char *path);
int			ft_file_is_writeable(const char *path);
char		*ft_get_file_path(const char *infile);
int			ft_infile(char *line);
int			ft_outfile(char *line);
int			ft_heredoc(char *stop);
size_t		ft_seglen_quoted(const char *str, char c);
char		**ft_split_quoted(const char *s, char c);

typedef struct s_cmd
{
	int	fd_in;
	int	fd_out;
	char	*executable;
	char	*args;
} t_cmd;

#endif
